#include <bits/stdc++.h>

using namespace std;



class SegmentTree {
public:
    SegmentTree(const vector<int>& data) {
        n = data.size();
        tree.resize(4 * n);
        build(data, 0, 0, n - 1);
    }

    void build(const vector<int>& data, int node, int start, int end) {
        if (start == end) {
            tree[node] = data[start];
        } else {
            int mid = (start + end) / 2;
            build(data, 2 * node + 1, start, mid);
            build(data, 2 * node + 2, mid + 1, end);
            tree[node] = tree[2 * node + 1] + tree[2 * node + 2];
        }
    }

    int sum(int L, int R) {
        return sum(0, 0, n - 1, L, R);
    }

private:
    vector<int> tree;
    int n;

    int sum(int node, int start, int end, int L, int R) {
        if (R < start || end < L) return 0;
        if (L <= start && end <= R) return tree[node];
        int mid = (start + end) / 2;
        return sum(2 * node + 1, start, mid, L, R) + sum(2 * node + 2, mid + 1, end, L, R);
    }
};

signed main() {
    int n, k;
    cin >> n >> k;
    if (k == 2) {
        vector<int> s(n);
        int sol = 0;
        for (int i = 0; i < n; i++) {
            cin >> s[i];
            sol += s[i];
        }
        if (s[0] > s[n - 1]) {
            cout << sol - 2 * s[n - 1];
            return 0;
        } else {
            cout << sol - 2 * s[0];
            return 0;
        }
    }
    vector<int> arr(n);
    for (int i = 0; i < n; ++i) cin >> arr[i];

    SegmentTree segTree(arr);
    vector<vector<int>> dp(k + 1, vector<int>(n + 1, INT_MIN));
    dp[0][0] = 0;

    for (int i = 1; i <= k; ++i) {
        for (int j = i; j <= n; ++j) {
            for (int p = i - 1; p < j; ++p) {
                int currentSum = segTree.sum(p, j - 1);
                dp[i][j] = max(dp[i][j], currentSum);
            }
        }
    }

    int maxDiff = INT_MIN;
    for (int i = 1; i <= k; ++i) {
        for (int j = i; j <= n; ++j) {
            for (int p = i - 1; p < j; ++p) {
                int currentSum = segTree.sum(p, j - 1);
                maxDiff = max(maxDiff, currentSum - dp[i - 1][p + 1]);
            }
        }
    }

    cout << maxDiff << endl;
    return 0;
}